package org.nakedobjects.nos.store.hibernate.property;

import java.lang.reflect.Method;
import java.util.Map;

import org.hibernate.HibernateException;
import org.hibernate.PropertyAccessException;
import org.hibernate.PropertyNotFoundException;
import org.hibernate.engine.SessionFactoryImplementor;
import org.hibernate.engine.SessionImplementor;
import org.hibernate.property.Getter;
import org.hibernate.property.PropertyAccessor;
import org.hibernate.property.Setter;
import org.nakedobjects.noa.adapter.NakedObject;
import org.nakedobjects.nof.core.context.NakedObjectsContext;


public class TitleAccessor implements PropertyAccessor {
    // private final static Logger LOG = Logger.getLogger(OidAccessor.class);

    private static final class TitleSetter implements Setter {
        private static final long serialVersionUID = 1L;
        private final Class clazz;
        private final String name;

        TitleSetter(Class clazz, String name) {
            this.clazz = clazz;
            this.name = name;
        }

        public Method getMethod() {
            return null;
        }

        public String getMethodName() {
            return null;
        }

        public void set(final Object target, final Object value, final SessionFactoryImplementor factory)
                throws HibernateException {
        // do nothing
        }
    }

    private static final class TitleGetter implements Getter {
        private static final long serialVersionUID = 1L;
        private final Class clazz;
        private final String name;

        TitleGetter(Class clazz, String name) {
            this.clazz = clazz;
            this.name = name;
        }

        public Object get(final Object target) throws HibernateException {
            try {
                // LOG.info("Getting oid - class="+target);
                NakedObject nakedTarget = NakedObjectsContext.getObjectLoader().getAdapterFor(target);
                // Hibernate might call to check what the unsaved value is - hence no adapter
                return nakedTarget == null ? null : nakedTarget.titleString();
            } catch (Exception e) {
                throw new PropertyAccessException(e, "could not get a value by reflection", false, clazz, name);
            }
        }

        public Method getMethod() {
            return null;
        }

        public String getMethodName() {
            return null;
        }

        public Class getReturnType() {
            return null;
        }

        public Object getForInsert(final Object target, final Map mergeMap, final SessionImplementor session)
                throws HibernateException {
            return get(target);
        }
    }

    public Setter getSetter(final Class theClass, final String propertyName) throws PropertyNotFoundException {
        return new TitleSetter(theClass, propertyName);
    }

    public Getter getGetter(final Class theClass, final String propertyName) throws PropertyNotFoundException {
        return new TitleGetter(theClass, propertyName);
    }

}
