package org.nakedobjects.nos.store.hibernate.property;

import org.nakedobjects.nos.store.hibernate.LongVersion;

/**
 * Accesses NakedObjects version for use in optimistic locking.
 */
public class VersionAccessor extends OptimisticLockAccessor {
	public static LongVersionAccessor VERSION_ACCESSOR = new LongVersionAccessor() {
		public Object get(final LongVersion version) {
		    return version.getVersionNumber();
		}

		public Class getReturnType() { return Long.class;	}

		public void set(final LongVersion version, final Object value) {
			version.setVersionNumber((Long)value);
		}
	};

	protected LongVersionAccessor getLongVersionAccessor() {
		return VERSION_ACCESSOR;
	}
}
// Copyright (c) Naked Objects Group Ltd.
